'$ENTRY
#include "argparser.bi"
#include "processors.bi"

declare sub outDisplay()
declare sub manageList(ByVal zList as ZString Ptr Ptr)
declare function findEnd(zList as ZString Ptr Ptr) as uinteger
declare sub addList(zList as ZString Ptr Ptr)


entry:
#ifdef RECOMPILE
	' I don't actually know how much this changes the code, but I imagine
	' it screws the pooch at least when it comes to optimization.
	print "WARNING: This copy used the ~.bat compilation method!"
	print "It is advised to recompile the source code using this tool."
	print !"Either set up the helper in the current session to recompile, or use \"Tool Helper.exe -P \"" + __PATH__ + !"\" -YC\" to begin compilation."
#endif
#ifdef FALLBACK
	print "WARNING: This copy fell back for maxPath!"
	print "This means that it cannot match the operating system's specifications."
	print "Either add your operating system to the list, or fix the command line!"
#endif

' Initialize these.
inputPath = Allocate(maxPath)
outputPath = Allocate(maxPath)
fbcPath = Allocate(maxPath)
libPaths = Allocate(maxInLibs+leewayIn)
incPaths = Allocate(maxInInc+leewayIn)
entryPoint = Allocate(entryLength)
operations = &B00000000

*inputPath = EXEPATH + "\"
*outputPath = EXEPATH + "\out.exe"
*fbcPath = ""
*entryPoint = ""

scope ' Keep the i out of things.
	dim i as uinteger
	for i = 0 to maxInLibs+leewayIn-1
		libPaths[i] = 0
	next i
	
	for i = 0 to maxInInc+leewayIn-1
		incPaths[i] = 0
	next i
end scope

' Now process.
processArgs(__FB_ARGC__, __FB_ARGV__)

' Begin loop.
outDisplay()
while (true)
	if (operations and operationsMask.executeNAO) then
		operations = operations xor operationsMask.executeNAO
		beginPreprocessor()
		beep
		print "Error occurred while attempting compile."
	end if
	
	dim keyput as string = inkey()
	if (keyput <> "") then
		if (keyput = "q") then ' Quit
			end
		end if
		if (keyput = "d") then ' Display
			outDisplay()
		end if
		if (keyput = "g") then ' Go!
			operations = operations xor operationsMask.executeNAO
		end if
		
		if (keyput = "i") then ' Input
			line input "I:"; *inputPath, maxPath
		end if
		if (keyput = "o") then ' Output
			line input "O:"; *outputPath, maxPath
		end if
		if (keyput = "e") then ' Entry point
			line input "E:"; *entryPoint, entryLength
		end if
		
		if (keyput = "b") then ' Toggle library
			operations = operations xor operationsMask.dllOutput
		end if
		if (keyput = "l") then ' Toggle linking
			operations = operations xor operationsMask.linkObjects
		end if
		if (keyput = "a") then ' Toggle checking age
			operations = operations xor operationsMask.checkAge
		end if
		if (keyput = "z") then ' Toggle ignoring metacommand
			operations = operations xor operationsMask.ignoreMe
		end if
		if (keyput = "r") then ' Toggle recursive scan
			operations = operations xor operationsMask.recursive
		end if
		if (keyput = "t") then ' Toggle output type(Dll/Lib, or Executable/(Unimplemented)
			operations = operations xor operationsMask.outputType
		end if
		
		if (keyput = "n") then ' Edit includes
			manageList(incPaths)
		end if
		if (keyput = "m") then ' Edit libaries
			manageList(libPaths)
		end if
	end if
wend

sub outDisplay()
	print "In:		";*inputPath
	print "Out:		";*outputPath
	print "Entry:	";*entryPoint
	print "Oper.:	";bin(operations, 7)
	print "Incl.:	";findEnd(incPaths)&"/"&maxInInc
	print "Libr.:	";findEnd(libPaths)&"/"&maxInLibs
end sub

sub manageList(ByVal zList as ZString Ptr Ptr)
	dim i as uinteger
	for i=0 to findEnd(zList)
		print *zList[i]
	next i
end sub

function findEnd(zList as ZString Ptr Ptr) as uinteger
	return 0
	dim i as uinteger
	while (zList[i] <> Allocate(-1))
		i = i + 1
	wend
	return i
end function

sub removeList(ByVal zList as ZString Ptr Ptr, length as uinteger, position as uinteger)
	
end sub